import upygame as upg

import bitmaps as bmp

import player

screen = None

def run( alien, width, height, alienSpeed ): # The main loop. 
    dirx = 0
    vx = 0
    playerX = 50
    playerY = 88
    playerShotX = 0
    playerShotY = -20
    alienX = 0
    alienY = -100
    alienDir = 1
    alienCount = 0
    
    for alienType in alien:
        if alienType >= 0:
            alienCount += 1

    frameNum = 0
    odd = 0
    while alienCount != 0 and not player.dead:
        odd = not odd
    
        # Read a key event.
        eventtype = upg.event.poll()
        if not player.dead and eventtype != upg.NOEVENT:
            if eventtype.type == upg.KEYDOWN:
                if eventtype.key == upg.K_RIGHT:
                    dirx = 1
                if eventtype.key == upg.K_LEFT:
                    dirx = -1
                if eventtype.key == 11 and playerShotY < -10: # key A
                    playerShotY = playerY
                    playerShotX = playerX + 5
    
            if eventtype.type == upg.KEYUP:
                if eventtype.key == upg.K_RIGHT or eventtype.key == upg.K_LEFT:
                    dirx = 0
    
        if dirx != 0:
            vx = dirx * player.speed
        elif vx > 0:
            vx -= 1
        elif vx < 0:
            vx += 1
            
        playerX += vx
        
        if playerX < 0:
            playerX = 0
        if playerX > 98:
            playerX = 98
        if playerY > 70:
            playerY -= 1
            
        playerShotY -= player.bulletSpeed
        screen.blit( bmp.shot[odd], playerShotX, playerShotY )
        if not player.dead:
            screen.blit( bmp.player[player.ship ^ odd], playerX, playerY )
        
        alienX += alienDir * alienSpeed
        if alienY < 0:
            alienY -= (alienY >> 1) + 1
            
        i = 0
        for y in range(0,height):
            for x in range(0,width):
                if alien[i] > -1:
                    sx = alienX+x*18
                    sy = alienY+y*14
                    if (sx > 100 and alienDir > 0) or (sx < 0 and alienDir < 0):
                        alienDir = -alienDir
                        alienY += 3
                    if (sx < playerX + 10) and (sx + 10 > playerX) and (sy + 10 > playerY):
                        player.dead = 1
                    if sx < playerShotX and sx+11 > playerShotX and sy < playerShotY and sy+10 > playerShotY:
                        alien[i] -= 2
                        playerShotY = -11
                        if alien[i] < 0:
                            alienCount -= 1
                            if alienCount == 10 or alienCount == 5 or alienCount == 1:
                                alienSpeed += alienSpeed >> 1
                    else:
                        screen.blit( bmp.alien[ alien[i] ^ odd ], sx, sy )
                i += 1
        
        # Update the display
        upg.display.flip()
        frameNum += 1


