# narrator.py
import upygame as upg
import umachine
import player
import gameloop

def splash( img ):
    looping = not player.dead
        
    while looping:
        eventtype = upg.event.poll()
        if eventtype != upg.NOEVENT and eventtype.type == upg.KEYDOWN:
            looping = False
        gameloop.screen.blit(img, 0, 0)        
        upg.display.flip()

        

def ask( question, A, ACB, B, BCB ):
    looping = not player.dead
        
    while looping:
        eventtype = upg.event.poll()
        if eventtype != upg.NOEVENT and eventtype.type == upg.KEYDOWN:
            if eventtype.key == 11:
                ACB()
                looping = False
            elif eventtype.key == 12:
                BCB()
                looping = False
        umachine.draw_text(55 - len(question)*4, 5, question, 9)
        umachine.draw_text(55 - len(A)*4, 20, A, 7)
        umachine.draw_text(55 - len(B)*4, 35, B, 7)
        upg.display.flip()

def say( text ):
    looping = not player.dead
        
    while looping:
        eventtype = upg.event.poll()
        if eventtype != upg.NOEVENT and eventtype.type == upg.KEYDOWN:
            looping = False
        umachine.draw_text(55 - len(text)*4, 5, text, 8)
        upg.display.flip()

    