# Anachronicle

import upygame as upg
import bitmaps as bmp
import narrator
import gameloop

import player


# Setup the screen.
gameloop.screen = upg.display.set_mode()

player.reset()

while True:
    narrator.splash(bmp.title)

    narrator.say("Level 1")
        
    gameloop.run([
         0,-1, 0,
        -1, 0,-1
    ], 3, 2, 1)
    
    narrator.say("Level 2")

    gameloop.run([
        1,0,2,0,1
    ], 5, 1, 1)
    
    narrator.ask(
        "Upgrade", 
        "A - Ship", player.upgradeShip, 
        "B - Gun", player.upgradeGun
        )
    
    narrator.say("Level 3")

    gameloop.run([
        -1, 3,-1, 2,-1,
         0,-1, 1,-1, 0
    ], 5, 2, 2)

    narrator.say("Level 4")

    gameloop.run([
        0,
        1
    ], 1, 2, 6)

    narrator.ask(
        "Upgrade", 
        "A - Ship", player.upgradeShip, 
        "B - Gun", player.upgradeGun
        )

    narrator.say("Level 5")
    
    gameloop.run([
         0,-1, 1,-1, 0,
         0,-1, 1,-1, 0,
         0,-1, 1,-1, 0,
         0,-1, 1,-1, 0
    ], 5, 4, 1)

    narrator.say("Level 6")

    gameloop.run([
        2,3,2,3,2,
        1,0,1,0,1,
        0,1,0,1,0
    ], 5, 3, 1)
    
    player.reset()
    
    narrator.say("Game Over")